unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, BGRABitmapTypes, BGRABitmap, Menus, ExtDlgs;

type
  TObject3D = class;
  TCube3D = class;

  { TForm1 }

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem19: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem20: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem22: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure MenuItem10Click(Sender: TObject);
    procedure MenuItem11Click(Sender: TObject);
    procedure MenuItem12Click(Sender: TObject);
    procedure MenuItem13Click(Sender: TObject);
    procedure MenuItem14Click(Sender: TObject);
    procedure MenuItem15Click(Sender: TObject);
    procedure MenuItem16Click(Sender: TObject);
    procedure MenuItem17Click(Sender: TObject);
    procedure MenuItem19Click(Sender: TObject);
    procedure MenuItem20Click(Sender: TObject);
    procedure MenuItem21Click(Sender: TObject);
    procedure MenuItem22Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
    procedure MenuItem9Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    bmp,background_image: TBGRABitmap;
    prevDate: TDateTime;
    pixelsize: integer;

    background: (bBlack, bChessboard, bGradient, bImage);
    ofsx,ofsy: integer;

    movingShape: (msNone, msWireCube,msDice,msRose);
    cube: TCube3D;
    dice,rose: TBGRABitmap;

    mask: (mNone, mHole, mFloodFill, mMirror, mText);
    hole: TBGRABitmap;
    angle: single;

    procedure DrawBmp;
  end;

  TPoint3D = record x,y,z: double; end;
  TPoint2D = record x,y: integer; visible: boolean; end;

  { TObject3D }

  TObject3D = class
    pts3D: array of TPoint3D;
    pts2D: array of TPoint2D;
    view, distance: TPoint3D;
    a,b,c: double;
    minz, zoom: double;
    procedure Compute;
    constructor Create;
    procedure Draw(bmp: TBGRABitmap; x0,y0: integer; color: TBGRAPixel); virtual;
  end;

  { TCube3D }

  TCube3D = class(TObject3D)
    constructor Create(r: double);
    procedure Draw(bmp: TBGRABitmap; x0,y0: integer; color: TBGRAPixel); override;
  end;

function point3D(x,y,z: double): TPoint3D;

var
  Form1: TForm1; 

implementation

function point3D(x, y, z: double): TPoint3D;
begin
  result.x := x;
  result.y := y;
  result.z := z;
end;

{ TForm1 }

procedure TForm1.Timer1Timer(Sender: TObject);
var
    xb,yb: integer;
    mirror: TBGRABitmap;
    dice_small,stretched_rose: TBGRABitmap;
    zoomfactor: double;
    zoomWidth,zoomHeight: integer;
begin
  Timer1.Enabled := false;

  if bmp=nil then
   bmp := TBGRABitmap.Create(ClientWidth div pixelsize,ClientHeight div pixelsize) else
    bmp.SetSize(ClientWidth div pixelsize,ClientHeight div pixelsize);

  case background of
  bBlack: bmp.Fill(clBlack);
  bChessboard:
    begin
      ofsx := (ofsx + 5-pixelsize) mod 100;
      ofsy := (ofsy + (7-pixelsize) div 2) mod 100;
      for xb := 0 to bmp.Width div 50+2 do
        for yb := 0 to bmp.Height div 50+2 do
          bmp.FillRect(xb*50-ofsx,yb*50-ofsy,xb*50-ofsx+50,yb*50-ofsy+50,
            BGRA(((xb xor yb) and 1)*255,((xb xor yb) and 1)*192,((xb xor yb) and 1)*64,255),dmSet);
    end;
  bGradient:
    begin
      for yb := 0 to bmp.Height-1 do
        bmp.SetHorizLine(0,yb,bmp.width-1, BGRA(128+yb*128 div bmp.height,128+yb*128 div bmp.height,255));

    end;
  bImage: begin
             bmp.Fill(clBlack);
             bmp.PutImage(0,0,background_image,dmSet);
          end;
  end;

  case movingShape of
  msNone: ;
  msWireCube:
    begin
      if Cube=nil then Cube := TCube3D.Create(400);
      Cube.a += 0.02;
      Cube.b += 0.01;
      Cube.c += 0.005;
      Cube.zoom := (bmp.Width+bmp.height) div 2;
      Cube.Compute;
      Cube.Draw(bmp,bmp.Width div 2, bmp.Height div 2, ColorToBGRA(clLime));
    end;
  msDice:
    begin
      if dice=nil then
      begin
        dice := TBGRABitmap.Create('dice.png');
        dice_small := TBGRABitmap(dice.Resample(dice.Width div 2,dice.Height div 2));
        dice.free;
        dice := dice_small;
      end;
      angle += 0.01;
      bmp.PutImage(round((cos(angle)+1)*bmp.width-dice.width) div 2,
         round((sin(angle*2)+1)*bmp.height-dice.Height) div 2,dice,dmDrawWithTransparency);
    end;
  msRose:
    begin
      if rose=nil then
      begin
        rose := TBGRABitmap.Create('pink_rose.png');
        stretched_rose := TBGRABitmap(rose.Resample(rose.width div 4,rose.height div 4));
        rose.free;
        rose := stretched_rose;
      end;
      angle += 0.01;

      zoomfactor := (sin(angle)*0.9+1)/2;
      if rose.width>rose.height then
      begin
         zoomHeight := round(rose.height*zoomfactor/2)*2;
         zoomWidth := round(rose.width*zoomHeight/rose.height/2)*2;
      end else
      begin
         zoomWidth := round(rose.width*zoomfactor/2)*2;
         zoomHeight := round(rose.height*zoomWidth/rose.width/2)*2;
      end;

      stretched_rose := TBGRABitmap(rose.Resample(zoomWidth, zoomHeight, rmFineResample));
      bmp.PutImage((bmp.width div 2-stretched_rose.width) div 2,
         (bmp.height div 2-stretched_rose.Height) div 2,stretched_rose,dmDrawWithTransparency);
      bmp.PutImage(bmp.width div 2+(bmp.width div 2-stretched_rose.width) div 2,
         (bmp.height div 2-stretched_rose.Height) div 2,stretched_rose,dmDrawWithTransparency);
      bmp.PutImage((bmp.width div 2-stretched_rose.width) div 2,
         bmp.Height div 2+(bmp.height div 2-stretched_rose.Height) div 2,stretched_rose,dmDrawWithTransparency);
      bmp.PutImage(bmp.width div 2+(bmp.width div 2-stretched_rose.width) div 2,
         bmp.Height div 2+(bmp.height div 2-stretched_rose.Height) div 2,stretched_rose,dmDrawWithTransparency);
      stretched_rose.Free;
    end;
  end;

   case mask of
  mNone: ;
  mHole:
    begin
      if hole=nil then
      begin
        hole:= TBGRABitmap.Create(300,300);
        hole.CanvasOpacity := 192;
        with hole.Canvas do
        begin
           Brush.Color := clBlue;
           Pen.Color := clWhite;
           Ellipse(0,0,300,300);
           Brush.Color := clBlack;
           Ellipse(100,100,200,200);
        end;
      end;
      bmp.PutImage((bmp.width-hole.Width) div 2,(bmp.height-hole.height) div 2, hole, dmDrawWithTransparency);
    end;
  mFloodfill: bmp.FloodFill(bmp.width div 2,bmp.height div 2, BGRA(255,0,0,128), fmDrawWithTransparency,128);
  mMirror:
    begin
       mirror := TBGRABitmap.Create(bmp.width*2 div 5,bmp.Height div 2);
       mirror.GetImageFromCanvas(Canvas,0,bmp.height div 4);
       mirror.HorizontalFlip;
       mirror.FillRect(0,0,mirror.width,mirror.height,BGRA(255,255,255,128),dmDrawWithTransparency);
       mirror.Rectangle(0,0,mirror.width,mirror.height,clWhite);
       bmp.PutImage(bmp.Width div 2,bmp.height div 4,mirror,dmSet);
       mirror.free;
    end;
  mText:
    begin
      bmp.FontHeight := bmp.Height div 2;
      bmp.FontStyle := [fsBold];
      bmp.TextOut(bmp.Width div 2,0,'Hello',BGRA(192,192,192,192),taCenter);
      bmp.TextOut(bmp.Width div 2,bmp.Height div 2,'World',BGRA(192,192,192,192),taCenter);
    end;
  end;

  Invalidate;
  Timer1.Enabled:= true;
end;

procedure TForm1.DrawBmp;
var curDate: TDateTime;
begin
  if Assigned(Bmp) then
  begin
    curDate := Now;
    Bmp.FontHeight := 20-2*pixelsize;
    Bmp.FontStyle := [];
    Bmp.TextOut(0,0,inttostr(round((curDate-prevDate)*24*60*60*1000))+' ms',clWhite);
    prevDate := curDate;

    Bmp.Draw(Canvas,rect(0,0,ClientWidth,ClientHeight),True);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  prevDate := Now;
  pixelsize := 1;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  DrawBmp;
end;


procedure TForm1.MenuItem2Click(Sender: TObject);
begin
  background := bBlack;
end;

procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  background := bChessboard;
end;

procedure TForm1.MenuItem13Click(Sender: TObject);
begin
  background := bGradient;
end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  movingShape := msNone;
end;

procedure TForm1.MenuItem6Click(Sender: TObject);
begin
  movingShape := msWireCube;
end;

procedure TForm1.MenuItem11Click(Sender: TObject);
begin
  movingShape := msDice;
end;

procedure TForm1.MenuItem17Click(Sender: TObject);
begin
  movingShape := msRose;
end;

procedure TForm1.MenuItem19Click(Sender: TObject);
begin
  pixelsize := 1;
end;

procedure TForm1.MenuItem20Click(Sender: TObject);
begin
  pixelsize := 2;
end;

procedure TForm1.MenuItem21Click(Sender: TObject);
begin
  pixelsize := 3;
end;

procedure TForm1.MenuItem22Click(Sender: TObject);
begin
  pixelsize := 4;
end;

procedure TForm1.MenuItem8Click(Sender: TObject);
begin
  mask := mNone;
end;

procedure TForm1.MenuItem9Click(Sender: TObject);
begin
  mask := mHole;
end;

procedure TForm1.MenuItem10Click(Sender: TObject);
begin
  mask := mFloodfill;
end;

procedure TForm1.MenuItem12Click(Sender: TObject);
begin
  mask := mMirror;
end;

procedure TForm1.MenuItem14Click(Sender: TObject);
begin
  mask := mText;
end;

procedure TForm1.MenuItem15Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then
  begin
    FreeAndNil(background_image);
    background_image := TBGRABitmap.Create(OpenPictureDialog1.FileName);
    background := bImage;
  end;
end;

procedure TForm1.MenuItem16Click(Sender: TObject);
begin
  if bmp=nil then exit;
  if SavePictureDialog1.Execute then
    bmp.SaveToFile(SavePictureDialog1.FileName);
end;

{ TObject3D }

procedure TObject3D.Compute;
var i: integer;
    x1,y1,z1 ,x2,y2,z2: double;
begin
     setlength(pts2D,length(pts3D));
     for i := 0 to high(pts3D) do
     with pts3D[i] do
     begin
          x2 := x-view.x;               y2 := y-view.y;                  z2 := z-view.z;
          x1 := x2*cos(a) + z2*sin(a);  y1 := y2;                        z1 := -x2*sin(a) + z2 * cos(a);
          x2 := x1;                     y2 := y1*cos(b) + z1*sin(b);     z2 := -y1*sin(b) + z1 * cos(b);
          x1 := x2*cos(c) + y2*sin(c);  y1 := -x2*sin(c) + y2 * cos(c);  z1 := z2;
          x2 := x1+distance.x;          y2 := y1+distance.y;             z2 := z1+distance.z;

          if z2 < minz then
          begin
               pts2D[i].visible := false;
          end else
          with pts2D[i] do
          begin
               visible := true;
               x := round(x2/z2*zoom);
               y := round(y2/z2*zoom);
          end;
     end;
end;

constructor TObject3D.Create;
begin
  minz := 0.1;
  zoom := 1200;
  view := point3D(0,0,0);
  distance := point3D(0,0,2400);
end;

procedure TObject3D.Draw(bmp: TBGRABitmap; x0, y0: integer; color: TBGRAPixel);
var i: integer;
begin
     for i := 0 to high(pts2D) do
     with pts2D[i] do
       if visible then
         bmp.DrawPixel(x+x0,y+y0,color);
end;

{ TCube3D }

constructor TCube3D.Create(r: double);
begin
  inherited Create;
  setlength(pts3D,8);
  with pts3D[0] do begin x := -r; y := -r; z := -r; end;
  with pts3D[1] do begin x := r; y := -r; z := -r; end;
  with pts3D[2] do begin x := r; y := r; z := -r; end;
  with pts3D[3] do begin x := -r; y := r; z := -r; end;
  with pts3D[4] do begin x := -r; y := -r; z := r; end;
  with pts3D[5] do begin x := r; y := -r; z := r; end;
  with pts3D[6] do begin x := r; y := r; z := r; end;
  with pts3D[7] do begin x := -r; y := r; z := r; end;
end;

procedure TCube3D.Draw(bmp: TBGRABitmap; x0, y0: integer; color: TBGRAPixel);
 procedure Side(p1,p2: integer);
 begin
   if pts2D[p1].visible and pts2D[p2].visible then
     bmp.DrawLineAntialias(pts2D[p1].x+x0,pts2D[p1].y+y0,pts2D[p2].x+x0,pts2D[p2].y+y0,color,true);
 end;

begin
  Side(0,1); Side(1,2); Side(2,3); Side(3,0);
  Side(4,5); Side(5,6); Side(6,7); Side(7,4);
  Side(0,4); Side(1,5); Side(2,6); Side(3,7);
end;

initialization
  {$I unit1.lrs}

end.

